function TNE_BGMsg_OnLoad()

TNE_BGMsg_Version = "3.1"

-- set default values. these will be overriden when variables are loaded
TNE_BGMsg_Default_Enabled = true
TNE_BGMsg_Default_NotificationDuration = 0
TNE_BGMsg_Default_FlashOnce = true

TNE_BGMsg_Default_FadeInTime = 0.3
TNE_BGMsg_Default_FadeOutTime = 0.7
TNE_BGMsg_Default_FadeInDelay = 0
TNE_BGMsg_Default_FadeOutDelay = 0

TNE_BGMsg_Default_Color = { 256, 256, 256 } -- r,g,b

TNE_BGMsg_Enabled = TNE_BGMsg_Default_Enabled
TNE_BGMsg_NotificationDuration = TNE_BGMsg_Default_NotificationDuration
TNE_BGMsg_FlashOnce = TNE_BGMsg_Default_FlashOnce

TNE_BGMsg_FadeInTime = TNE_BGMsg_Default_FadeInTime
TNE_BGMsg_FadeOutTime = TNE_BGMsg_Default_FadeOutTime
TNE_BGMsg_FadeInDelay = TNE_BGMsg_Default_FadeInDelay
TNE_BGMsg_FadeOutDelay = TNE_BGMsg_Default_FadeOutDelay

TNE_BGMsg_Color = TNE_BGMsg_Default_Color

-- command line
SlashCmdList["BGMsgCMD"] = TNE_BGMsg_CMD
SLASH_BGMsgCMD1 = "/bgmsg"

this:SetAlpha(0)
this:Show()
this:RegisterEvent("VARIABLES_LOADED")

end

function TNE_BGMsg_ApplySettings()

local frame = getglobal("BGMsgFrame")

UIFrameFlashRemoveFrame(frame)
UIFrameFadeRemoveFrame(frame)
UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)

-- register or unregister when turning modes on or off
if (TNE_BGMsg_Enabled) then
  frame:RegisterEvent("CHAT_MSG_BATTLEGROUND")
  frame:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
  TNE_BGMsg_LastSentBGMsg = 0
  BGMsgFrameTexture:SetVertexColor(unpack(TNE_BGMsg_Color))
else
  frame:UnregisterEvent("CHAT_MSG_BATTLEGROUND")
  frame:UnregisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
end

end

function TNE_BGMsg_OnEvent(event)

local now, frame = GetTime(), BGMsgFrame

if (frame.locked) then
  return
end

if (event == "CHAT_MSG_BATTLEGROUND") then
  if not (TNE_BGMsg_LastSentBGMsg > now - TNE_BGMsg_NotificationDuration) then
    UIFrameFlash(frame, TNE_BGMsg_FadeInTime, TNE_BGMsg_FadeOutTime, TNE_BGMsg_FlashOnce and 2 or -1, nil, TNE_BGMsg_FadeOutDelay, TNE_BGMsg_FadeInDelay)
  end
elseif (event == "CHAT_MSG_BATTLEGROUND_LEADER") then
  TNE_BGMsg_LastSentBGMsg = now
  UIFrameFlashRemoveFrame(frame)
  UIFrameFadeRemoveFrame(frame)
  UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)
end

end

function TNE_BGMsg_CMD(arg1)

if (not arg1) then
  return
end

ShowUIPanel(BGMsgSettingsFrame)

end