function TNE_RaidMsg_OnLoad()

TNE_RaidMsg_Version = "3.1"

-- set default values. these will be overriden when variables are loaded
TNE_RaidMsg_Default_Enabled = true
TNE_RaidMsg_Default_NotificationDuration = 0
TNE_RaidMsg_Default_FlashOnce = true

TNE_RaidMsg_Default_FadeInTime = 0.3
TNE_RaidMsg_Default_FadeOutTime = 0.7
TNE_RaidMsg_Default_FadeInDelay = 0
TNE_RaidMsg_Default_FadeOutDelay = 0

TNE_RaidMsg_Default_Color = { 256, 256, 256 } -- r,g,b

TNE_RaidMsg_Enabled = TNE_RaidMsg_Default_Enabled
TNE_RaidMsg_NotificationDuration = TNE_RaidMsg_Default_NotificationDuration
TNE_RaidMsg_FlashOnce = TNE_RaidMsg_Default_FlashOnce

TNE_RaidMsg_FadeInTime = TNE_RaidMsg_Default_FadeInTime
TNE_RaidMsg_FadeOutTime = TNE_RaidMsg_Default_FadeOutTime
TNE_RaidMsg_FadeInDelay = TNE_RaidMsg_Default_FadeInDelay
TNE_RaidMsg_FadeOutDelay = TNE_RaidMsg_Default_FadeOutDelay

TNE_RaidMsg_Color = TNE_RaidMsg_Default_Color

-- command line
SlashCmdList["RaidMsgCMD"] = TNE_RaidMsg_CMD
SLASH_RaidMsgCMD1 = "/raidmsg"

this:SetAlpha(0)
this:Show()
this:RegisterEvent("VARIABLES_LOADED")

end

function TNE_RaidMsg_ApplySettings()

local frame = getglobal("RaidMsgFrame")

UIFrameFlashRemoveFrame(frame)
UIFrameFadeRemoveFrame(frame)
UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)

-- register or unregister when turning modes on or off
if (TNE_RaidMsg_Enabled) then
  frame:RegisterEvent("CHAT_MSG_RAID")
  frame:RegisterEvent("CHAT_MSG_RAID_LEADER")
  TNE_RaidMsg_LastSentRaidMsg = 0
  RaidMsgFrameTexture:SetVertexColor(unpack(TNE_RaidMsg_Color))
else
  frame:UnregisterEvent("CHAT_MSG_RAID")
  frame:UnregisterEvent("CHAT_MSG_RAID_LEADER")
end

end

function TNE_RaidMsg_OnEvent(event)

local now, frame = GetTime(), RaidMsgFrame

if (frame.locked) then
  return
end

if (event == "CHAT_MSG_RAID") then
  if not (TNE_RaidMsg_LastSentRaidMsg > now - TNE_RaidMsg_NotificationDuration) then
    UIFrameFlash(frame, TNE_RaidMsg_FadeInTime, TNE_RaidMsg_FadeOutTime, TNE_RaidMsg_FlashOnce and 2 or -1, nil, TNE_RaidMsg_FadeOutDelay, TNE_RaidMsg_FadeInDelay)
  end
elseif (event == "CHAT_MSG_RAID_LEADER") then
  TNE_RaidMsg_LastSentRaidMsg = now
  UIFrameFlashRemoveFrame(frame)
  UIFrameFadeRemoveFrame(frame)
  UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)
end

end

function TNE_RaidMsg_CMD(arg1)

if (not arg1) then
  return
end

ShowUIPanel(RaidMsgSettingsFrame)

end