function TNE_SystemMsg_OnLoad()

TNE_SystemMsg_Version = "3.1"

-- set default values. these will be overriden when variables are loaded
TNE_SystemMsg_Default_Enabled = true
TNE_SystemMsg_Default_NotificationDuration = 0
TNE_SystemMsg_Default_FlashOnce = true

TNE_SystemMsg_Default_FadeInTime = 0.3
TNE_SystemMsg_Default_FadeOutTime = 0.7
TNE_SystemMsg_Default_FadeInDelay = 0
TNE_SystemMsg_Default_FadeOutDelay = 0

TNE_SystemMsg_Default_Color = { 256, 256, 256 } -- r,g,b

TNE_SystemMsg_Enabled = TNE_SystemMsg_Default_Enabled
TNE_SystemMsg_NotificationDuration = TNE_SystemMsg_Default_NotificationDuration
TNE_SystemMsg_FlashOnce = TNE_SystemMsg_Default_FlashOnce

TNE_SystemMsg_FadeInTime = TNE_SystemMsg_Default_FadeInTime
TNE_SystemMsg_FadeOutTime = TNE_SystemMsg_Default_FadeOutTime
TNE_SystemMsg_FadeInDelay = TNE_SystemMsg_Default_FadeInDelay
TNE_SystemMsg_FadeOutDelay = TNE_SystemMsg_Default_FadeOutDelay

TNE_SystemMsg_Color = TNE_SystemMsg_Default_Color

-- command line
SlashCmdList["SystemMsgCMD"] = TNE_SystemMsg_CMD
SLASH_SystemMsgCMD1 = "/systemmsg"

this:SetAlpha(0)
this:Show()
this:RegisterEvent("VARIABLES_LOADED")

end

function TNE_SystemMsg_ApplySettings()

local frame = getglobal("SystemMsgFrame")

UIFrameFlashRemoveFrame(frame)
UIFrameFadeRemoveFrame(frame)
UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)

-- register or unregister when turning modes on or off
if (TNE_SystemMsg_Enabled) then
  frame:RegisterEvent("CHAT_MSG_SYSTEM")
  frame:RegisterEvent("CHAT_MSG_SYSTEM_INFORM")
  TNE_SystemMsg_LastSentSystemMsg = 0
  SystemMsgFrameTexture:SetVertexColor(unpack(TNE_SystemMsg_Color))
else
  frame:UnregisterEvent("CHAT_MSG_SYSTEM")
  frame:UnregisterEvent("CHAT_MSG_SYSTEM_INFORM")
end

end

function TNE_SystemMsg_OnEvent(event)

local now, frame = GetTime(), SystemMsgFrame

if (frame.locked) then
  return
end

if (event == "CHAT_MSG_SYSTEM") then
  if not (TNE_SystemMsg_LastSentSystemMsg > now - TNE_SystemMsg_NotificationDuration) then
    UIFrameFlash(frame, TNE_SystemMsg_FadeInTime, TNE_SystemMsg_FadeOutTime, TNE_SystemMsg_FlashOnce and 2 or -1, nil, TNE_SystemMsg_FadeOutDelay, TNE_SystemMsg_FadeInDelay)
  end
elseif (event == "CHAT_MSG_SYSTEM_INFORM") then
  TNE_SystemMsg_LastSentSystemMsg = now
  UIFrameFlashRemoveFrame(frame)
  UIFrameFadeRemoveFrame(frame)
  UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)
end

end

function TNE_SystemMsg_CMD(arg1)

if (not arg1) then
  return
end

ShowUIPanel(SystemMsgSettingsFrame)

end